#!/bin/sh

XCPU_DIR=/etc/xcpu
PUBLIC_KEY=$XCPU_DIR/admin_key.pub

if [ "x$STATE" = "xinit" ]; then
cat <<END
echo -ne "\\\r                                                                               \\\r"
echo
echo "Starting XCPU on: $NODENAME"
echo "           Group: $GROUPNAME"
echo "         Node ID: $NODEID"
echo
echo "Building XCPU environment..."

mkdir -p $XCPU_DIR
cat <<EOF > $PUBLIC_KEY
`cat $PUBLIC_KEY`
EOF
mkdir -p /root/.ssh
cat <<EOF > /root/.ssh/id_rsa.pub
`cat /root/.ssh/id_rsa.pub`
EOF
echo "root::0:0:root:/root:/bin/sh" > /etc/passwd
if [ ! -f "/sbin/xcpufs" ]; then
echo "Obtaining required XCPU components"
if ! getfile modules/xcpu/xcpufs; then
   echo
   echo "Can not continue... Rebooting."
   sleep 2
   /sbin/reboot
fi
test -d /tmp || mkdir /tmp
chmod 777 /tmp
chmod 555 xcpufs
mv xcpufs /sbin/
fi
echo "Setting hostname to $NODENAME"
hostname $NODENAME
echo "Starting XCPU daemon"
if xcpufs; then
echo "XCPU daemon running"
else
echo "UNKNOWN ERROR!"
echo
reboot30
fi
exit
END
fi
